import pygame, sys
from pygame.locals import *

# 迷路のマップデータ。（まだ作っていない…。）
MAP = [
    [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],

    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],

    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
    [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
]

CHIP_SIZE = 32
MAP_WIDTH = 20
MAP_HEIGHT = 15


# 画像を読み込む
def image_load(filename):
    try:
        image = pygame.image.load(filename)
    except pygame.error:
        print("Cannot load image:" % filename)
        raise SystemExit
    image = image.convert()
    return image


# 画像を分割する
def split_image_load(image, frame_x, frame_y):
    # 画像のサイズ判定。
    size_x = image.get_width()
    size_y = image.get_height()

    imageList = []

    for j in range(0, size_y, frame_y):
        for i in range(0, size_x, frame_x):
            surface = pygame.Surface((frame_x, frame_y))
            surface.blit(image, (0, 0), (j, i, frame_x, frame_y))
            surface.set_colorkey(surface.get_at((0, 0)), RLEACCEL)
            surface.convert(surface)
            imageList.append(surface)

    return imageList


class Map(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = image_load("MapChip.bmp")
        self.imageList = split_image_load(self.image, 32, 32)

    def draw(self, screen):
        transColor = self.image.get_at((0, 0))
        self.image.set_colorkey(transColor, RLEACCEL)
        for y in range(MAP_HEIGHT):
            for x in range(MAP_WIDTH):
                if MAP[y][x] == 1:
                    screen.blit(self.imageList[1], (x * CHIP_SIZE, y * CHIP_SIZE))
                else:
                    screen.blit(self.imageList[0], (x * CHIP_SIZE, y * CHIP_SIZE))


def main():
    pygame.init()
    screen = pygame.display.set_mode((640, 480))
    maze = Map()
    while True:
        pygame.display.update()
        maze.draw(screen)
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                sys.exit()


if __name__ == '__main__':
    main()
